unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ToolWin, ComCtrls, Grids, DBGrids, Db, ActnList,
  StdCtrls, DBCtrls, ExtCtrls, Unit8, GrToExcel, ShellApi, VKDBFDataSet,
  DBTables;

type
  TForm2 = class(TForm)
    MainMenu1: TMainMenu;
    One1: TMenuItem;
    One2: TMenuItem;
    DBGrid1: TDBGrid;
    DBFNTX1: TVKDBFNTX;
    DataSource1: TDataSource;
    SetDeleted1: TMenuItem;
    Actions1: TMenuItem;
    GotoRecord1: TMenuItem;
    DBFHeader1: TMenuItem;
    DBFStructure1: TMenuItem;
    SetFilter1: TMenuItem;
    Orders1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    StatusBar1: TStatusBar;
    ActionList1: TActionList;
    aOEM: TAction;
    aSetDeleted: TAction;
    aGoToR: TAction;
    aHeader: TAction;
    aStruct: TAction;
    aFilter: TAction;
    aOrders: TAction;
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolBar2: TToolBar;
    FilterText: TComboBox;
    ToolButton5: TToolButton;
    ToolBar3: TToolBar;
    ToolButton6: TToolButton;
    aMasterDital: TAction;
    ToolButton7: TToolButton;
    N1: TMenuItem;
    MasterDital1: TMenuItem;
    aLocate: TAction;
    ToolButton8: TToolButton;
    aLocate1: TMenuItem;
    aOpenAttr: TAction;
    N2: TMenuItem;
    Openattributes1: TMenuItem;
    ToolButton9: TToolButton;
    ToolBar4: TToolBar;
    ToolButton10: TToolButton;
    aToExcel: TAction;
    N3: TMenuItem;
    GridToExcel1: TMenuItem;
    OpenDialog1: TOpenDialog;
    aClearFld: TAction;
    N4: TMenuItem;
    ClearfieldSetNullAltDel1: TMenuItem;
    PopupMenu1: TPopupMenu;
    aFileToLob: TAction;
    LoadfiletoLob1: TMenuItem;
    LoadfiletoLob2: TMenuItem;
    aLobToFile: TAction;
    OpenDialog2: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SavefilefromLOB1: TMenuItem;
    SavefilefromLOB2: TMenuItem;
    ClearfieldSetNullAltDel2: TMenuItem;
    aTruncate: TAction;
    N5: TMenuItem;
    TruncateZAP1: TMenuItem;
    N6: TMenuItem;
    TruncateZAP2: TMenuItem;
    N7: TMenuItem;
    DeleteRecallrecord1: TMenuItem;
    Pack1: TMenuItem;
    ReindexAll1: TMenuItem;
    aPack: TAction;
    Pack2: TMenuItem;
    aReindexAll: TAction;
    ReindexAll2: TMenuItem;
    N8: TMenuItem;
    aDelRecall: TAction;
    DeleteRecallrecord2: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure aOEMExecute(Sender: TObject);
    procedure aSetDeletedExecute(Sender: TObject);
    procedure DBFNTX1AfterScroll(DataSet: TDataSet);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure aGoToRExecute(Sender: TObject);
    procedure aHeaderExecute(Sender: TObject);
    procedure aStructExecute(Sender: TObject);
    procedure aFilterExecute(Sender: TObject);
    procedure FilterTextChange(Sender: TObject);
    procedure DBGrid1ColumnMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure aOrdersExecute(Sender: TObject);
    procedure aMasterDitalExecute(Sender: TObject);
    procedure aLocateExecute(Sender: TObject);
    procedure aOpenAttrExecute(Sender: TObject);
    procedure aToExcelExecute(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure DBGrid1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure aClearFldExecute(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DBGrid1ColEnter(Sender: TObject);
    procedure aFileToLobExecute(Sender: TObject);
    procedure aLobToFileExecute(Sender: TObject);
    procedure aTruncateExecute(Sender: TObject);
    procedure aPackExecute(Sender: TObject);
    procedure aReindexAllExecute(Sender: TObject);
    procedure aDelRecallExecute(Sender: TObject);
  private
    { Private declarations }
    ColMoved: Boolean;
    oLocate: TForm8;
    function GetMasterSource: TDataSource;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); overload; override;
    constructor Create(AOwner: TComponent; FileName: String); overload;
    constructor LoadFile(AOwner: TComponent; FileName: String);
    destructor Destroy; override;

    property MasterSource: TDataSource read GetMasterSource;

  end;

implementation

uses Unit1, GoToR, Unit3, Unit4, Unit5, Unit7, Unit9, Unit10, Unit11,
  Unit12, f_BLob;

{$R *.DFM}

{ TForm2 }

constructor TForm2.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

constructor TForm2.Create(AOwner: TComponent; FileName: String);
begin
  Create(AOwner);
  oLocate := nil;
  Caption := FileName;
  DBFNTX1.DBFFileName := FileName;
  try
    DBFNTX1.Active := true;
  except
    on e: Exception do MessageDlg(e.Message, mtError, [mbOK], 0);
  end;
  ColMoved := false;
  oLocate := TForm8.Create(self);
end;

constructor TForm2.LoadFile(AOwner: TComponent; FileName: String);
begin
  Create(AOwner);
  Caption := FileName;
  DBFNTX1.DBFFileName := FileName;
  ColMoved := false;
  oLocate := TForm8.Create(self);
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TForm2.aOEMExecute(Sender: TObject);
begin
  DBFNTX1.OEM := not DBFNTX1.OEM;
  One2.Checked := DBFNTX1.OEM;
  DBFNTX1.Refresh;
end;

procedure TForm2.aSetDeletedExecute(Sender: TObject);
begin
  DBFNTX1.SetDeleted := not DBFNTX1.SetDeleted;
  SetDeleted1.Checked := DBFNTX1.SetDeleted;
  //DBFNTX1.Refresh;
end;

procedure TForm2.DBFNTX1AfterScroll(DataSet: TDataSet);
var
  S: String;
begin
  S := '';
  if DBFNTX1.Deleted then S := 'Deleted';
  StatusBar1.Panels[0].Text := Format('%d / %d  %s', [DBFNTX1.RecNo, DBFNTX1.Last_Rec, S]);
end;

procedure TForm2.DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
var
  OldC: TColor;
begin
  if not (gdFocused in State) then
  begin
    {$B+}
    if DBFNTX1.Deleted then
    begin
      OldC := DBGrid1.Canvas.Brush.Color;
      DBGrid1.Canvas.Brush.Color := {cl3DLight}clInfoBk{clAqua};
      DBGrid1.Canvas.FillRect(Rect);
      DBGrid1.DefaultDrawColumnCell(Rect, DataCol, Column, State);
      DBGrid1.Canvas.Brush.Color := OldC;
    end else
      DBGrid1.DefaultDrawColumnCell(Rect, DataCol, Column, State);
    {$B-}
  end else
    DBGrid1.DefaultDrawColumnCell(Rect, DataCol, Column, State);
end;

procedure TForm2.aGoToRExecute(Sender: TObject);
var
  oG: TGoToR;
begin
  oG := TGoToR.Create(self);
  try
    if oG.ShowModal = mrOk then
    begin
      if oG.NewRec <> -1 then
        DBFNTX1.RecNo := oG.NewRec;
        DBFNTX1.Refresh;
    end;
  finally
    oG.Destroy;
  end;
end;

procedure TForm2.aHeaderExecute(Sender: TObject);
var
  oO: TForm3;
begin
  oO := TForm3.Create(self);
  try
    oO.Caption := 'DBF Header';
    oO.Memo1.Lines.Clear;
    oO.Memo1.Lines.Add(Format('dbf_id: 0x%x', [DBFNTX1.Header.dbf_id]));
    oO.Memo1.Lines.Add(Format('last_update: (%d, %d, %d)', [DBFNTX1.Header.last_update[0], DBFNTX1.Header.last_update[1], DBFNTX1.Header.last_update[2]]));
    oO.Memo1.Lines.Add(Format('last_rec: %d', [DBFNTX1.Header.last_rec]));
    oO.Memo1.Lines.Add(Format('data_offset:  %d', [DBFNTX1.Header.data_offset]));
    oO.Memo1.Lines.Add(Format('rec_size: %d', [DBFNTX1.Header.rec_size]));
    oO.Memo1.Lines.Add(Format('prod_ind: %x', [DBFNTX1.Header.prod_ind]));
    oO.Memo1.Lines.Add(Format('lang: %x', [DBFNTX1.Header.lang]));
    oO.ShowModal;
  finally
    oO.Destroy;
  end;
end;

procedure TForm2.aStructExecute(Sender: TObject);
var
  oO: TForm3;
  i: Integer;
  qq: TVKDBFFieldDef;
begin
  oO := TForm3.Create(self);
  try
    oO.Caption := 'DBF Fields info';
    oO.Memo1.Lines.Clear;
    oO.Memo1.Lines.Add('      Name Type Length Prec   Offset    Extended Type');
    oO.Memo1.Lines.Add('---------- ---- ------ ---- --------  ---------------');
    for i := 0 to DBFNTX1.DBFFieldDefs.Count -1 do
    begin
      qq := DBFNTX1.DBFFieldDefs.Items[i];
      if qq.field_type <> 'E' then
        oO.Memo1.Lines.Add(Format('%10s%5s%7d%5d%9d%17s', [qq.Name, qq.field_type, qq.Len, qq.Dec, qq.Offset, '']))
      else
        oO.Memo1.Lines.Add(Format('%10s%5s%7d%5d%9d%17s', [qq.Name, qq.field_type, qq.Len, qq.Dec, qq.Offset, ExtType2Str(qq.extend_type)]));
    end;
    oO.ShowModal;
  finally
    oO.Free;
  end;
end;

procedure TForm2.aFilterExecute(Sender: TObject);
begin
  if FilterText.Items.IndexOf(FilterText.Text) = -1 then
    FilterText.Items.Insert(0, FilterText.Text);
  DBFNTX1.Filtered := false;
  if FilterText.Text <> '' then begin
    DBFNTX1.Filter := FilterText.Text;
    DBFNTX1.Filtered := true;
  end;
end;

procedure TForm2.FilterTextChange(Sender: TObject);
begin
  if FilterText.Text = '' then DBFNTX1.Filtered := false;
end;

procedure TForm2.DBGrid1ColumnMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
  ColMoved := true;
end;

procedure TForm2.DBGrid1TitleClick(Column: TColumn);
var
  oB: TBookmark;
  oGrid: TDBGrid;
  oDataSet: TDataSet;
  oField: TField;
  f: boolean;
  oFnd: TForm4;
begin
  if not ColMoved then
  begin
    if FilterText.Text <> '' then begin
      if FilterText.Items.IndexOf(FilterText.Text) = -1 then
        FilterText.Items.Insert(0, FilterText.Text);
      f := false;
      oGrid := Column.Grid as TDBGrid;
      oDataSet := oGrid.DataSource.DataSet;
      oFnd := TForm4.Create(self);
      oFnd.Show;
      oB := oDataSet.GetBookmark;
      oDataSet.DisableControls;
      try
        oDataSet.Next;
        oField := Column.Field;
        while not oDataSet.Eof do
        begin
          if Pos(FilterText.Text, oField.AsString) <> 0 then
          begin
            f := true;
            Break;
          end;
          oFnd.R := TVKDBFNTX(oDataSet).RecNo;
          if oFnd.Cancel then Break;
          oDataSet.Next;
        end;
        if not f then
        begin
          beep;
          oDataSet.GotoBookmark(oB);
        end;
      finally
        oFnd.Free;
        oDataSet.FreeBookmark(oB);
        oDataSet.EnableControls;
      end;
    end;
  end;
  ColMoved := false;
end;

procedure TForm2.aOrdersExecute(Sender: TObject);
var
  oO: TForm5;
begin
  oO := TForm5.Create(self);
  oO.ShowModal;
end;

procedure TForm2.aMasterDitalExecute(Sender: TObject);
var
  oM: TForm7;
begin
  oM := TForm7.Create(self);
  try
    oM.ShowModal;
  finally
    oM.Destroy;
  end;
end;

function TForm2.GetMasterSource: TDataSource;
begin
  if (DBFNTX1 <> nil) and DBFNTX1.Active then
    Result := TVKDBFNTX(DBFNTX1).DataSource
  else
    Result := nil;
end;

procedure TForm2.aLocateExecute(Sender: TObject);
begin
  oLocate.ShowModal;
end;

destructor TForm2.Destroy;
begin
  if oLocate <> nil then oLocate.Destroy;
  inherited Destroy;
end;

procedure TForm2.aOpenAttrExecute(Sender: TObject);
var
  oO: TForm9;
begin
  oO := TForm9.Create(self);
  try
    oO.FDBF := dbfntx1;
    oO.cActive.Checked := dbfntx1.Active;
    oO.eDbfFileName.text := dbfntx1.DBFFileName;
    oO.cRead.Checked := dbfntx1.AccessMode.OpenRead;
    oO.cReadWrite.Checked := dbfntx1.AccessMode.OpenReadWrite;
    oO.cWrite.Checked := dbfntx1.AccessMode.OpenWrite;
    oO.cDenyNone.Checked := dbfntx1.AccessMode.ShareDenyNone;
    {oO.cDenyRead.Checked := dbfntx1.AccessMode.ShareDenyRead;}
    oO.cDenyWrite.Checked := dbfntx1.AccessMode.ShareDenyWrite;
    oO.cExclusive.Checked := dbfntx1.AccessMode.ShareExclusive;
    oO.eWaitBusyRes.Text := IntToStr(dbfntx1.WaitBusyRes);
    oO.eBuffSize.Text := IntToStr(dbfntx1.BufferSize);
    oO.CryptActive.Checked := dbfntx1.Crypt.Active;
    if dbfntx1.Crypt.CryptMethod = cmXOR then
      oO.CryptMethod.Text := 'cmXOR'
    else
      if dbfntx1.Crypt.CryptMethod = cmGost then
        oO.CryptMethod.Text := 'cmGost'
      else
        oO.CryptMethod.Text := 'cmNONE';
    oO.CryptPass.Text := dbfntx1.Crypt.Password;
    oO.ShowModal;
  finally
    oO.Free;
  end;
end;

procedure TForm2.aToExcelExecute(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    GrToEx(DBGrid1, OpenDialog1.FileName);
    ShellExecute(self.Handle, Pchar('open'), pChar(OpenDialog1.FileName), Pchar('/n'), nil, SW_SHOWNORMAL);
  end;
end;

procedure TForm2.DBGrid1CellClick(Column: TColumn);
var
  c: TForm12;
  oM10: TForm10;
  oM: TForm11;
  oB: TBlobView;
begin
  if Column.Field.IsBlob then begin
    case TBlobField(Column.Field).BlobType of
      ftMemo:
        begin
          c := TForm12.Create(self);
          c.ShowModal;
          case c.Id of
            0:
              begin
                oM := TForm11.Create(self);
                oM.DataSource := DataSource1;
                oM.DataField := Column.Field.FieldName;
                oM.ShowModal;
                oM.Free;
              end;
            1:
              begin
                oM10 := TForm10.Create(self);
                oM10.DataSource := DataSource1;
                oM10.DataField := Column.Field.FieldName;
                oM10.ShowModal;
                oM10.Free;
              end;
          end;
          c.Free;
        end;
      ftBlob:
        begin
          oB := TBlobView.Create(self);
          oB.DataSource := DataSource1;
          oB.DataField := Column.Field.FieldName;
          oB.ShowModal;
          oB.Free;
        end;
    end;
  end;
end;

procedure TForm2.DBGrid1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ( ssAlt in Shift ) and ( ( Key = VK_DELETE ) or ( Key = VK_BACK ) ) then begin
    aClearFldExecute(self);
  end;
end;

procedure TForm2.aClearFldExecute(Sender: TObject);
begin
  if DBFNTX1.IsCursorOpen then begin
    DBGrid1.DataSource.DataSet.Edit;
    DBGrid1.SelectedField.Clear;
    DBGrid1.DataSource.DataSet.Post;
  end;
end;

procedure TForm2.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  if DBFNTX1.IsCursorOpen then begin
    if DBGrid1.SelectedField.IsNull then
      StatusBar1.Panels[1].Text := 'Null'
    else
      StatusBar1.Panels[1].Text := '';
  end;
end;

procedure TForm2.DBGrid1ColEnter(Sender: TObject);
begin
  if DBGrid1.SelectedField.IsNull then
    StatusBar1.Panels[1].Text := 'Null'
  else
    StatusBar1.Panels[1].Text := '';
end;

procedure TForm2.aFileToLobExecute(Sender: TObject);
begin
  if DBGrid1.SelectedField.IsBlob then begin
    if OpenDialog2.Execute then begin
      DBGrid1.DataSource.DataSet.Edit;
      TBlobField(DBGrid1.SelectedField).LoadFromFile(OpenDialog2.FileName);
      DBGrid1.DataSource.DataSet.Post;
    end;
  end;
end;

procedure TForm2.aLobToFileExecute(Sender: TObject);
begin
  if DBGrid1.SelectedField.IsBlob then begin
    if SaveDialog1.Execute then begin
      if DBGrid1.DataSource.DataSet.State in [dsEdit, dsInsert] then DBGrid1.DataSource.DataSet.Post;
      TBlobField(DBGrid1.SelectedField).SaveToFile(SaveDialog1.FileName);
    end;
  end;
end;

procedure TForm2.aTruncateExecute(Sender: TObject);
begin
  if MessageDlg('All records will be deleted from table. Are you sure?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    DBFNTX1.Truncate;
end;

procedure TForm2.aPackExecute(Sender: TObject);
begin
  if MessageDlg('All records marked as deleted will be remove from table. Are you sure?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    DBFNTX1.Pack;
end;

procedure TForm2.aReindexAllExecute(Sender: TObject);
begin
  if MessageDlg('Are you sure?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    DBFNTX1.ReindexAll;
end;

procedure TForm2.aDelRecallExecute(Sender: TObject);
begin
  DBFNTX1.Deleted := not DBFNTX1.Deleted;
end;

end.
