unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, VKDBFDataSet, VKDBFNTX;

type
  TForm5 = class(TForm)
    ListView1: TListView;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    OD: TOpenDialog;
    Button2: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  end;

implementation

uses Unit2, Unit6;

{$R *.DFM}

procedure TForm5.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TForm5.Button4Click(Sender: TObject);
begin
  Close;
end;

constructor TForm5.Create(AOwner: TComponent);
var
  oD: TVKDBFNTX;
  i: Integer;
begin
  inherited Create(AOwner);
  oD := TForm2(AOwner).DBFNTX1;
  ListView1.Items.Clear;
  with ListView1.Items.Add do begin
    Caption := 'Physical order (recno)';
    Data := Pointer(0);
    if oD.Indexes.ActiveObject = nil then Selected := true;
  end;
  for i := 0 to oD.Indexes.Count - 1 do begin
    with ListView1.Items.Add do begin
      Caption := TVKNTXIndex(oD.Indexes[i]).NTXFileName;
      Data := Pointer(i + 1);
      SubItems.Add(TVKNTXIndex(oD.Indexes[i]).KeyExpresion);
      if oD.Indexes.ActiveObject = TVKNTXIndex(oD.Indexes[i]) then Selected := true;
    end;
  end;
end;

procedure TForm5.Button1Click(Sender: TObject);
var
  oT: TVKDBFNTX;
  i: Integer;
  oI: TVKNTXIndex;
begin
  oT := TForm2(Owner).DBFNTX1;
  if OD.Execute then begin
    oI := TVKNTXIndex(oT.Indexes.Add);
    oI.NTXFileName := OD.FileName;
    oI.Open;
    oI.Active := true;
    with ListView1.Items.Add do begin
      Caption := oI.NTXFileName;
      i := oI.Index + 1;
      Data := Pointer(i);
      SubItems.Add(oI.KeyExpresion);
      Selected := true;
    end;
  end;
  ActiveControl := ListView1;
end;

procedure TForm5.ListView1DblClick(Sender: TObject);
begin
  Close;
end;

procedure TForm5.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  oT: TVKDBFNTX;
begin
  oT := TForm2(Owner).DBFNTX1;
  if ListView1.Selected <> nil then
    oT.SetOrder(Integer(ListView1.Selected.Data));
end;

procedure TForm5.Button3Click(Sender: TObject);
var
  oP: TForm6;
  oT: TVKDBFNTX;
  oI: TVKNTXIndex;
  i: Integer;
begin
  if ListView1.Selected <> nil then begin
    oT := TForm2(Owner).DBFNTX1;
    i := Integer(ListView1.Selected.Data);
    if i > 0 then begin
      oI := TVKNTXIndex(oT.Indexes[i - 1]);
      oP := TForm6.Create(self);
      try
        oP.oI := oI;
        oP.ShowModal;
      finally
        oP.Free;
      end;
    end;
  end;
  ActiveControl := ListView1;
end;

procedure TForm5.Button2Click(Sender: TObject);
var
  oT: TVKDBFNTX;
  i: Integer;
  oI: TVKNTXIndex;
  oP: TForm6;
begin
  oT := TForm2(Owner).DBFNTX1;
  oI := TVKNTXIndex(oT.Indexes.Add);
  oP := TForm6.Create(self);
  try
    oP.oI:= oI;
    oP.ShowModal;
    if oP.Ok then begin
      oI.CreateIndex;
      with ListView1.Items.Add do begin
        Caption := oI.NTXFileName;
        i := oI.Index + 1;
        Data := Pointer(i);
        SubItems.Add(oI.KeyExpresion);
        Selected := true;
      end;
    end else
      oT.Indexes.Delete(oI.Index);
  finally
    oP.Free;
  end;
  ActiveControl := ListView1;
end;

procedure TForm5.Button5Click(Sender: TObject);
var
  oT: TVKDBFNTX;
  oI: TVKNTXIndex;
  i: Integer;
begin
  if ListView1.Selected <> nil then begin
    oT := TForm2(Owner).DBFNTX1;
    i := Integer(ListView1.Selected.Data);
    if i > 0 then begin
      oI := TVKNTXIndex(oT.Indexes[i - 1]);
      oI.Reindex;
      ShowMessage('Ok');
    end;
    oT.Refresh;
  end;
  ActiveControl := ListView1;
end;

procedure TForm5.Button6Click(Sender: TObject);
var
  oT: TVKDBFNTX;
  i: Integer;
  oI: TVKNTXIndex;
  oP: TForm6;
begin
  oT := TForm2(Owner).DBFNTX1;
  oI := TVKNTXIndex(oT.Indexes.Add);
  oP := TForm6.Create(self);
  try
    oP.oI:= oI;
    oP.ShowModal;
    if oP.Ok then begin
      oI.CreateCompactIndex;
      with ListView1.Items.Add do begin
        Caption := oI.NTXFileName;
        i := oI.Index + 1;
        Data := Pointer(i);
        SubItems.Add(oI.KeyExpresion);
        Selected := true;
      end;
    end else
      oT.Indexes.Delete(oI.Index);
  finally
    oP.Free;
  end;
  ActiveControl := ListView1;
end;

procedure TForm5.Button7Click(Sender: TObject);
var
  oT: TVKDBFNTX;
  i: Integer;
begin
  if ListView1.Selected <> nil then begin
    oT := TForm2(Owner).DBFNTX1;
    i := Integer(ListView1.Selected.Data);
    if i > 0 then begin
      oT.Indexes.Delete(i - 1);
      ListView1.Items.Delete(ListView1.Selected.Index);
      ShowMessage('Ok');
    end;
    oT.Refresh;
  end;
  ActiveControl := ListView1;
end;

end.
